diff --git a/src/backend/executor/nodeHash.c b/src/backend/executor/nodeHash.c
index 11db08f..5301bc0 100644
--- a/src/backend/executor/nodeHash.c
+++ b/src/backend/executor/nodeHash.c
@@ -1496,18 +2566,29 @@ ExecHashSkewTableInsert(HashJoinTable hashtable,
 	MinimalTuple tuple = ExecFetchSlotMinimalTuple(slot);
 	HashJoinTuple hashTuple;
 	int			hashTupleSize;
+	dsa_pointer tuple_pointer;
 
 	/* Create the HashJoinTuple */
 	hashTupleSize = HJTUPLE_OVERHEAD + tuple->t_len;
-	hashTuple = (HashJoinTuple) MemoryContextAlloc(hashtable->batchCxt,
-												   hashTupleSize);
+	if (HashJoinTableIsShared(hashtable))
+	{
+		tuple_pointer = dsa_allocate(hashtable->area, hashTupleSize);
+		hashTuple = (HashJoinTuple) dsa_get_address(hashtable->area,
+													tuple_pointer);
+	}
+	else
+	{
+		tuple_pointer = InvalidDsaPointer;
+		hashTuple = (HashJoinTuple) MemoryContextAlloc(hashtable->batchCxt,
+													   hashTupleSize);
+	}
 	hashTuple->hashvalue = hashvalue;
 	memcpy(HJTUPLE_MINTUPLE(hashTuple), tuple, tuple->t_len);
 	HeapTupleHeaderClearMatch(HJTUPLE_MINTUPLE(hashTuple));
 
 	/* Push it onto the front of the skew bucket's list */
-	hashTuple->next = hashtable->skewBucket[bucketNumber]->tuples;
-	hashtable->skewBucket[bucketNumber]->tuples = hashTuple;
+	insert_tuple_into_skew_bucket(hashtable, bucketNumber, hashTuple,
+								  tuple_pointer);
 
 	/* Account for space used, and back off if we've used too much */
 	hashtable->spaceUsed += hashTupleSize;
@@ -1538,6 +2619,9 @@ ExecHashRemoveNextSkewBucket(HashJoinTable hashtable)
 	int			batchno;
 	HashJoinTuple hashTuple;
 
+	/* TODO: skew buckets not yet supported for parallel mode */
+	Assert(!HashJoinTableIsShared(hashtable));
+
 	/* Locate the bucket to remove */
 	bucketToRemove = hashtable->skewBucketNums[hashtable->nSkewBuckets - 1];
 	bucket = hashtable->skewBucket[bucketToRemove];
@@ -1552,10 +2636,10 @@ ExecHashRemoveNextSkewBucket(HashJoinTable hashtable)
 	ExecHashGetBucketAndBatch(hashtable, hashvalue, &bucketno, &batchno);
 
 	/* Process all tuples in the bucket */
-	hashTuple = bucket->tuples;
+	hashTuple = first_tuple_in_skew_bucket(hashtable, bucketToRemove);
 	while (hashTuple != NULL)
 	{
-		HashJoinTuple nextHashTuple = hashTuple->next;
+		HashJoinTuple nextHashTuple = next_tuple_in_bucket(hashtable, hashTuple);
 		MinimalTuple tuple;
 		Size		tupleSize;
 
@@ -1581,8 +2665,8 @@ ExecHashRemoveNextSkewBucket(HashJoinTable hashtable)
 			memcpy(copyTuple, hashTuple, tupleSize);
 			pfree(hashTuple);
 
-			copyTuple->next = hashtable->buckets[bucketno];
-			hashtable->buckets[bucketno] = copyTuple;
+			insert_tuple_into_bucket(hashtable, bucketno, copyTuple,
+									 InvalidDsaPointer);
 
 			/* We have reduced skew space, but overall space doesn't change */
 			hashtable->spaceUsedSkew -= tupleSize;
@@ -1591,8 +2675,8 @@ ExecHashRemoveNextSkewBucket(HashJoinTable hashtable)
 		{
 			/* Put the tuple into a temp file for later batches */
 			Assert(batchno > hashtable->curbatch);
-			ExecHashJoinSaveTuple(tuple, hashvalue,
-								  &hashtable->innerBatchFile[batchno]);
+			ExecHashJoinSaveTuple(hashtable, tuple, hashvalue,
+								  batchno, true);
 			pfree(hashTuple);
 			hashtable->spaceUsed -= tupleSize;
 			hashtable->spaceUsedSkew -= tupleSize;
@@ -1636,6 +2720,198 @@ ExecHashRemoveNextSkewBucket(HashJoinTable hashtable)
 }
 
 /*
+ * Allocate 'size' bytes from the currently active shared HashMemoryChunk, or
+ * create a new chunk if necessary.  This is similar to the private memory
+ * version, but also deals with 'preload' chunks and coordination with other
+ * participants.
+ *
+ * If respect_work_mem is true, then return NULL if the number of batches has
+ * been increased in order to avoid exceeding work_mem.  Pass false to allow
+ * work_mem to be exceeded (as can be temporarily needed by ExecHashShrink, or
+ * if increasing the number of batches doesn't seem to be helping us shrink
+ * the memory usage).
+ */
+static void *
+dense_alloc_shared(HashJoinTable hashtable,
+				   Size size,
+				   dsa_pointer *shared,
+				   bool preload,
+				   bool respect_work_mem)
+{
+	dsa_pointer chunk_shared;
+	HashMemoryChunk chunk;
+	Size chunk_size;
+
+	/* just in case the size is not already aligned properly */
+	size = MAXALIGN(size);
+
+	/*
+	 * Fast path: if there is enough space in this backend's current chunk,
+	 * then we can allocate without any locking or work_mem accounting.  If
+	 * HASH_CHUNK_SIZE is large enough, this strategy should keep lock
+	 * contention low.  It doesn't matter if another participant has decided
+	 * to increase the number of batches; we'll finish filling up this chunk
+	 * and then find out about the increase when we need to allocate a new
+	 * chunk.
+	 */
+	chunk = preload ? hashtable->chunk_preload : hashtable->chunk;
+	if (chunk != NULL &&
+		size < HASH_CHUNK_THRESHOLD &&
+		chunk->maxlen - chunk->used >= size)
+	{
+		void *result;
+
+		chunk_shared = preload
+			? hashtable->chunk_preload_shared
+			: hashtable->chunk_shared;
+		Assert(chunk == dsa_get_address(hashtable->area, chunk_shared));
+		*shared = chunk_shared +
+			offsetof(HashMemoryChunkData, data) +
+			chunk->used;
+		result = chunk->data + chunk->used;
+		chunk->used += size;
+		chunk->ntuples += 1;
+
+		Assert(chunk->used <= chunk->maxlen);
+		Assert(result == dsa_get_address(hashtable->area, *shared));
+
+		return result;
+	}
+
+	/*
+	 * Slow path: try to allocate a new chunk, while also coordinating with
+	 * other participants to keep memory usage under work_mem by increasing
+	 * the number of batches as required.
+	 */
+	LWLockAcquire(&hashtable->shared->chunk_lock, LW_EXCLUSIVE);
+
+	/* Check if some other participant has increased nbatch. */
+	if (hashtable->shared->nbatch > hashtable->nbatch)
+	{
+		Assert(!preload);
+		Assert(respect_work_mem);
+		extend_batch_file_arrays(hashtable, hashtable->shared->nbatch);
+
+		hashtable->chunk = NULL;
+		hashtable->chunk_shared = InvalidDsaPointer;
+		LWLockRelease(&hashtable->shared->chunk_lock);
+
+		/*
+		 * Whenever nbatch changes, every participant attached to
+		 * shrink_barrier must run ExecHashShrink to help shrink the hash
+		 * table.  So return NULL to tell caller to go and do that.
+		 */
+		return NULL;
+	}
+
+	/* Oversized tuples get their own chunk. */
+	if (size > HASH_CHUNK_THRESHOLD)
+		chunk_size = size + offsetof(HashMemoryChunkData, data);
+	else
+		chunk_size = HASH_CHUNK_SIZE;
+
+	/* If appropriate, check if work_mem would be exceeded by a new chunk. */
+	if (respect_work_mem &&
+		hashtable->shared->shrinking_enabled &&
+		(hashtable->shared->size +
+		 hashtable->shared->size_preloaded +
+		 chunk_size) > (work_mem * 1024L))
+	{
+		/*
+		 * It would.  If allocating for the current batch (ie not preloading
+		 * the next batch), increase number of batches so we can shrink the
+		 * hash table.
+		 */
+		if (!preload)
+		{
+			hashtable->shared->nbatch *= 2;
+			extend_batch_file_arrays(hashtable, hashtable->shared->nbatch);
+
+			/* All allocated chunks now need to be shrunk. */
+			hashtable->shared->chunks_to_shrink = hashtable->shared->chunks;
+			hashtable->shared->chunks = InvalidDsaPointer;
+			hashtable->shared->tuples_in_memory = 0;
+			hashtable->shared->tuples_written_out = 0;
+
+			hashtable->chunk = NULL;
+			hashtable->chunk_shared = InvalidDsaPointer;
+		}
+		LWLockRelease(&hashtable->shared->chunk_lock);
+
+		/*
+		 * If the caller is preloading, it should now stop doing that because
+		 * there is no more work_mem.  If it is loading, it should now run
+		 * ExecHashShrink so we can get some memory back.
+		 */
+		return NULL;
+	}
+
+	/* We are cleared to allocate a new chunk. */
+	chunk_shared = dsa_allocate(hashtable->area, chunk_size);
+	if (!DsaPointerIsValid(chunk_shared))
+		ereport(ERROR,
+				(errcode(ERRCODE_PROGRAM_LIMIT_EXCEEDED),
+				 errmsg("out of memory")));
+	TRACE_POSTGRESQL_HASH_ALLOCATE_CHUNK(chunk_size);
+	if (preload)
+		hashtable->shared->size_preloaded += chunk_size;
+	else
+		hashtable->shared->size += chunk_size;
+
+	/* Set up the chunk. */
+	chunk = (HashMemoryChunk) dsa_get_address(hashtable->area, chunk_shared);
+	*shared = chunk_shared + offsetof(HashMemoryChunkData, data);
+	chunk->maxlen = chunk_size - offsetof(HashMemoryChunkData, data);
+	chunk->used = size;
+	chunk->ntuples = 1;
+
+	/*
+	 * Push it onto the appropriate list of chunks, so that it can be found if
+	 * we need to rebucket or shrink the whole hash table.
+	 */
+	ExecHashPushChunk(hashtable, chunk, chunk_shared,
+					  preload
+					  ? &hashtable->shared->chunks_preloaded
+					  : &hashtable->shared->chunks);
+
+	if (size > HASH_CHUNK_THRESHOLD)
+	{
+		/*
+		 * Count oversized tuples immediately, but don't bother making this
+		 * chunk the 'current' chunk because it has no more space in it for
+		 * next time.
+		 */
+		if (preload)
+			++hashtable->shared->tuples_next_batch;
+		else
+			++hashtable->shared->tuples_this_batch;
+	}
+	else
+	{
+		/*
+		 * Make this the current chunk so that we can use the fast path to
+		 * fill the rest of it up in future called.  We will count this tuple
+		 * later, when the chunk is full.
+		 */
+		if (preload)
+		{
+			hashtable->chunk_preload = chunk;
+			hashtable->chunk_preload_shared = chunk_shared;
+		}
+		else
+		{
+			hashtable->chunk = chunk;
+			hashtable->chunk_shared = chunk_shared;
+		}
+	}
+	LWLockRelease(&hashtable->shared->chunk_lock);
+
+	Assert(chunk->data == dsa_get_address(hashtable->area, *shared));
+
+	return chunk->data;
+}
+
+/*
  * Allocate 'size' bytes from the currently active HashMemoryChunk
  */
 static void *
@@ -1653,26 +2929,28 @@ dense_alloc(HashJoinTable hashtable, Size size)
 	 */
 	if (size > HASH_CHUNK_THRESHOLD)
 	{
+
 		/* allocate new chunk and put it at the beginning of the list */
-		newChunk = (HashMemoryChunk) MemoryContextAlloc(hashtable->batchCxt,
-								 offsetof(HashMemoryChunkData, data) + size);
+		newChunk = (HashMemoryChunk)
+			MemoryContextAlloc(hashtable->batchCxt,
+							   offsetof(HashMemoryChunkData, data) + size);
 		newChunk->maxlen = size;
 		newChunk->used = 0;
-		newChunk->ntuples = 0;
+		newChunk->ntuples=  0;
 
 		/*
 		 * Add this chunk to the list after the first existing chunk, so that
 		 * we don't lose the remaining space in the "current" chunk.
 		 */
-		if (hashtable->chunks != NULL)
+		if (hashtable->chunk != NULL)
 		{
-			newChunk->next = hashtable->chunks->next;
-			hashtable->chunks->next = newChunk;
+			newChunk->next.private = hashtable->chunk->next.private;
+			hashtable->chunk->next.private = newChunk;
 		}
 		else
 		{
-			newChunk->next = hashtable->chunks;
-			hashtable->chunks = newChunk;
+			newChunk->next.private = NULL;
+			hashtable->chunk = newChunk;
 		}
 
 		newChunk->used += size;
@@ -1685,27 +2963,27 @@ dense_alloc(HashJoinTable hashtable, Size size)
 	 * See if we have enough space for it in the current chunk (if any). If
 	 * not, allocate a fresh chunk.
 	 */
-	if ((hashtable->chunks == NULL) ||
-		(hashtable->chunks->maxlen - hashtable->chunks->used) < size)
+	if ((hashtable->chunk == NULL) ||
+		(hashtable->chunk->maxlen - hashtable->chunk->used) < size)
 	{
 		/* allocate new chunk and put it at the beginning of the list */
-		newChunk = (HashMemoryChunk) MemoryContextAlloc(hashtable->batchCxt,
-					  offsetof(HashMemoryChunkData, data) + HASH_CHUNK_SIZE);
-
+		newChunk = (HashMemoryChunk)
+			MemoryContextAlloc(hashtable->batchCxt,
+							   offsetof(HashMemoryChunkData, data) +
+							   HASH_CHUNK_SIZE);
+		newChunk->next.private = hashtable->chunk;
+		hashtable->chunk = newChunk;
 		newChunk->maxlen = HASH_CHUNK_SIZE;
 		newChunk->used = size;
 		newChunk->ntuples = 1;
 
-		newChunk->next = hashtable->chunks;
-		hashtable->chunks = newChunk;
-
 		return newChunk->data;
 	}
 
 	/* There is enough space in the current chunk, let's add the tuple */
-	ptr = hashtable->chunks->data + hashtable->chunks->used;
-	hashtable->chunks->used += size;
-	hashtable->chunks->ntuples += 1;
+	ptr = hashtable->chunk->data + hashtable->chunk->used;
+	hashtable->chunk->used += size;
+	hashtable->chunk->ntuples += 1;
 
 	/* return pointer to the start of the tuple memory */
 	return ptr;
